﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Comfile.ComfilePi
{
    public static class GPIO
    {
        static bool _isInitialized;
        static int __pi;
        static int _pi
        {
            get
            {
                if (!_isInitialized)
                {
                    AppDomain.CurrentDomain.ProcessExit += CurrentDomain_ProcessExit;

                    int result = pigpio.pigpio_start(IntPtr.Zero, IntPtr.Zero);
                    if (result < 0)
                    {
                        throw new Exception("GPIO.Open failed");
                    }

                    _isInitialized = true;

                    __pi = result;
                }

                return __pi;
            }
        }

        private static void CurrentDomain_ProcessExit(object sender, EventArgs e)
        {
            pigpio.pigpio_stop(_pi);
        }

        #region Inputs
        static readonly Input _input06 = new Input(_pi, 6);
        public static Input Input06
        {
            get { return _input06; }
        }

        static readonly Input _input07 = new Input(_pi, 7);
        public static Input Input07
        {
            get { return _input07; }
        }

        static readonly Input _input10 = new Input(_pi, 10);
        public static Input Input10
        {
            get { return _input10; }
        }

        static readonly Input _input11 = new Input(_pi, 11);
        public static Input Input11
        {
            get { return _input11; }
        }

        static readonly Input _input16 = new Input(_pi, 16);
        public static Input Input16
        {
            get { return _input16; }
        }

        static readonly Input _input17 = new Input(_pi, 17);
        public static Input Input17
        {
            get { return _input17; }
        }

        static readonly Input _input18 = new Input(_pi, 18);
        public static Input Input18
        {
            get { return _input18; }
        }

        static readonly Input[] _inputs = new Input[]
        {
            _input06,
            _input07,
            _input10,
            _input11,
            _input16,
            _input17,
            _input18,
        };
        public static ReadOnlyCollection<Input> Inputs
        {
            get { return Array.AsReadOnly(_inputs); }
        }

        #endregion Inputs

        #region Outputs
        static readonly Output _output19 = new Output(_pi, 19);
        public static Output Output19
        {
            get { return _output19; }
        }

        static readonly Output _output20 = new Output(_pi, 20);
        public static Output Output20
        {
            get { return _output20; }
        }

        static readonly Output _output21 = new Output(_pi, 21);
        public static Output Output21
        {
            get { return _output21; }
        }

        static readonly Output _output22 = new Output(_pi, 22);
        public static Output Output22
        {
            get { return _output22; }
        }

        static readonly Output _output23 = new Output(_pi, 23);
        public static Output Output23
        {
            get { return _output23; }
        }

        static readonly Output _output24 = new Output(_pi, 24);
        public static Output Output24
        {
            get { return _output24; }
        }

        static readonly Output _output45 = new Output(_pi, 45);
        public static Output Output45
        {
            get { return _output45; }
        }

        

        static readonly Output[] _outputs = new Output[] 
        {
            _output19,
            _output20,
            _output21,
            _output22,
            _output23,
            _output24,
            _output45,
        };
        public static ReadOnlyCollection<Output> Outputs
        {
            get { return Array.AsReadOnly(_outputs); }
        }
        #endregion Outputs
    }
}
